/*
 *  * Copyright (C) 2001 Alejandro Aguilar Sierra <asierra@servidor.unam.mx>
 *  *
 *  * This program is free software; you can redistribute it and/or modify
 *  * it under the terms of the GNU General Public License as published by
 *  * the Free Software Foundation; either version 2 of the License, or
 *  * (at your option) any later version.
 *  *
 *  * This program is distributed in the hope that it will be useful,
 *  * but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  * GNU General Public License for more details.
 *  *
 *  * You should have received a copy of the GNU General Public License
 *  * along with this program; if not, write to the Free Software Foundation,
 *  * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  */

#ifndef _FT_TITLER_H
#define _FT_TITLER_H 1


#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_GLYPH_H

#define MAX_GLYPHS 1024



class FT_Titler 
{
 public:
   /// Font size and text
   FT_Titler(int size, char *text, char *fontpath);

   /// Set the image address where the string will be drawn
   void setPixels(uint8_t *p, int r) { 
      pixels = p;
      row_w = r;
   }
   
   void setPad(int p) {
      pad = p;
   }
   
   void setColors(DVColor fg, DVColor bg) {
      colorfg = fg;
      colorbg = bg;
   }

   void setFontFileName(char *fn) {
      fname = fn;
   }   
	
   void getMetrics(int &w, int &h);
   
   void drawText(int x, int y);
   
   void setXFontName(char *fontname);
   
 protected:
   void initString();
   void computeStringbbox( FT_BBox  *abbox );
   void drawBitmap(FT_Bitmap &bitmap, FT_Int bitmap_left, FT_Int bitmap_top);
   
   
 private:   
   char *text;
   char *fname;
   //int pen_x, pen_y;
   int num_chars;
//   FT_Vector pen;
   
   // Image properties
   uint8_t *pixels;
   int row_w;
//   int width; 
//   int height;
   int pad;
   DVColor colorfg, colorbg;
   
   // Font properties
   int size;
   FT_Glyph      glyphs[ MAX_GLYPHS ];   // glyph image
   FT_Vector     pos   [ MAX_GLYPHS ];   // glyph position
   FT_UInt       num_glyphs;    
};


#endif
